//officiel 12_01_15
//fonctionne avec  avec I2CattinyDip_09_01_15
//desactivation de l'I2C avec les conseils du forum
//erreur de patch corrige
//supression du flash au demarage
//pour que l'arpdress-board fonctionne, le port bas doit etre debranche.


/* Pour Arpschuino, gradation soft PWM sur les 16 canneaux. 
Frequence PWM 160 hz
Adressage avec l'Arpdress board

2 clignotements brefs = l'adresse est prise depuis l'EEPROM.
1 cligotement jaune (arpdress board) et 1 vert =  l'adresse est prise depuis l'arpdress board et Ã©crite dans l'EEPROM.
1 cligotement jaune (arpdress board) et 10 vert =  l'adresse est non conforme, l'adresse par defaut est prise.

Puis la led verte vibrillonne des qu'elle recoit du DMX.
*/

#include <Wire.h>
#define SLAVE_ADDR 0x26

#include <EEPROM.h>
int EEPROMaddr = 0;

#define __DEBUG_SOFTPWM__ 0

#include <lib_dmx.h>

#define default_adress (1)//adresse par defaut
#define nbre_circuits (16)//

#include <SoftPWMMaster_mod.h>

#define    DMX512     (0)  

byte adress = default_adress;

int led_temoin=4;
boolean var_led=0;

//////////////////////////PATCH////////////////////////////////////////////


SOFTPWM_DEFINE_CHANNEL( 0, DDRD, PORTD, PORTD3);
SOFTPWM_DEFINE_CHANNEL( 1, DDRD, PORTD, PORTD5 );
SOFTPWM_DEFINE_CHANNEL( 2, DDRD, PORTD, PORTD6 );
SOFTPWM_DEFINE_CHANNEL( 3, DDRB, PORTB, PORTB5 );
SOFTPWM_DEFINE_CHANNEL( 4, DDRB, PORTB, PORTB4 );
SOFTPWM_DEFINE_CHANNEL( 5, DDRB, PORTB, PORTB1 );
SOFTPWM_DEFINE_CHANNEL( 6, DDRB, PORTB, PORTB2 );
SOFTPWM_DEFINE_CHANNEL( 7, DDRB, PORTB, PORTB3 );
SOFTPWM_DEFINE_CHANNEL( 8, DDRD, PORTD, PORTD2 );
SOFTPWM_DEFINE_CHANNEL( 9, DDRB, PORTB, PORTB0 );//corrige !
SOFTPWM_DEFINE_CHANNEL( 10, DDRC, PORTC, PORTC0 );
SOFTPWM_DEFINE_CHANNEL( 11, DDRC, PORTC, PORTC1 );
SOFTPWM_DEFINE_CHANNEL( 12, DDRC, PORTC, PORTC2 );
SOFTPWM_DEFINE_CHANNEL( 13, DDRC, PORTC, PORTC3 );
SOFTPWM_DEFINE_CHANNEL( 14, DDRC, PORTC, PORTC4 );
SOFTPWM_DEFINE_CHANNEL( 15, DDRC, PORTC, PORTC5 );

//DDRD = DDRD | B11111100;  // this is safer as it sets pins 2 to 7 as outputs
	                  // without changing the value of pins 0 & 1, which are RX & TX 

 ////////////////////////////////////////////////////////////////////////////
 
SOFTPWM_DEFINE_OBJECT( nbre_circuits );



void setup(){
 /////////////////////pin 2 a  17 en sorties////////////////////////////
  for(int i=2;i<18;i++)
    {
     pinMode(i, OUTPUT); 
    }
//  DDRD = DDRD | B11111100;  // this is safer as it sets pins 2 to 7 as outputs
//	                  // without changing the value of pins 0 & 1, which are RX & TX 
//  DDRB = DDRB | B00111111;  // 8 a 13 output
//
//  DDRC = DDRC | B00111111; //14 a 19 output
  
  bitWrite (PORTD,4,1);// equivalent a digitalWrite(led_temoin,HIGH);
  
///////////////presence de l'arpdress-board ? /////////////////////////
  boolean arpdress = true;//variable pour indiquer la presence (ou non) de l'arpdress board 
  if ((digitalRead (18) == HIGH) && (digitalRead (19) == HIGH)){
 
    char arpdress_code[8] = {'a','r','p','d','r','e','s','s'};
    
  //  PORTC = PORTC | 00110000; //pullup sur sda et slc
    Wire.begin(); 
    Wire.beginTransmission(SLAVE_ADDR);      // declare l'adresse de l'esclave qui va recevoir le code
    Wire.write(0xB);                        // envoie la donnee
    Wire.endTransmission();                  // arrete la transmission
    
  //  digitalWrite(led_temoin,LOW);
    delay (500);
  //  digitalWrite(led_temoin,HIGH);
    
    Wire.requestFrom(SLAVE_ADDR, 8);     // request 8 bytes from slave
    
    if (Wire.available()) {
      char reponse[8] = {0};
      delay(200);
      for(int i=0; i<8; i++){
        reponse[i] = Wire.read();
      }
      delay(200);
      for(int i=0;i<8;i++) {
         if (arpdress_code[i]!=reponse[i]) arpdress = false;
      }
    } 
    
    else {
      arpdress = false;
    }
  } 
  else {
    arpdress = false;
  }
   /////////////////////////////////////////////////////////////////////////// 
    byte unite = 0;
    byte disaine = 0;
    byte centaine = 0;
    
    if (arpdress == true){//si l'arpdress-board est branche et le port bas debranche
  /////////////////////////I2C///////////////////////////////////////////
  //////envoie requete///////
      //Wire.begin(); 
      Wire.beginTransmission(SLAVE_ADDR);      // declare l'adresse de l'esclave qui va recevoir le code
      Wire.write(0xDE);                        // envoie la donnee
      Wire.endTransmission();                  // arrete la transmission
      delay(500);
      
      //////////on attend 3 byte//////////////////////////////////////////
  
      Wire.requestFrom(SLAVE_ADDR, 3);     // request 3 bytes from slave
       
      if (Wire.available()) {
    
         unite = Wire.read();
         disaine = Wire.read();
         centaine = Wire.read();
         
     //////////////////////////////EEPROM/////////////////////////////////
         EEPROM.write(EEPROMaddr, centaine);
         EEPROMaddr ++;
         EEPROM.write(EEPROMaddr, disaine);
         EEPROMaddr ++;
         EEPROM.write(EEPROMaddr, unite);
         bitWrite (PORTD,4,0);
         delay (500);
         bitWrite (PORTD,4,1);
      }
    }
    else{
       centaine = EEPROM.read(EEPROMaddr);
       EEPROMaddr ++;
       disaine = EEPROM.read(EEPROMaddr);
       EEPROMaddr ++;
       unite = EEPROM.read(EEPROMaddr);

       bitWrite (PORTD,4,0);     //  digitalWrite(led_temoin,LOW);
       delay (100);
       bitWrite (PORTD,4,1);
       delay (100);
       bitWrite (PORTD,4,0);
       delay (100);
       bitWrite (PORTD,4,1);
       
    }
    adress =(centaine*100)+(disaine*10)+(unite);
    if(adress<513 && adress>0){}
    else{
     adress=default_adress;
     for (int i=0;i<10;i++){
      bitWrite (PORTD,4,0);
      delay (500);
      bitWrite (PORTD,4,1);
      delay (500);
     }
   
    }
   
    delay(1000);
    
    TWBR=0;
    TWCR=0;//desactive l'I2C
    
    pinMode(18, OUTPUT);
    pinMode(19, OUTPUT);
  
  
///////////////////////////////////////////////////////////////////////
  SoftPWM.begin(160);//NE FONCTIONNE PAS A 200// Ok 180
  
  ArduinoDmx0.attachRXInterrupt  (frame_received);
  ArduinoDmx0.set_control_pin(7);    // Arduino output pin for MAX485 input/output control (connect to MAX485 pins 2-3) 
  ArduinoDmx0.set_rx_address(adress);      // set rx0 dmx start address
  ArduinoDmx0.set_rx_channels(nbre_circuits);     // number of rx channels
  ArduinoDmx0.init_rx(DMX512);        // starts universe 0 as rx, NEW Parameter DMX mode
}

void loop()
{
  delay(500);//la led s'eteind apres 500ms sans reception DMX
  bitWrite (PORTD,4,1);
} 

void frame_received(uint8_t universe) // Custom ISR: fired when all channels in one universe are received
{
  //led_temoin verte
  if (universe == 0) // USART0
  {
    if(var_led == 0)
    {
      bitWrite (PORTD,4,0); 
      var_led = 1;
    }
    else
    {
      bitWrite (PORTD,4,1);
      var_led = 0;
    }
  }

  
  /////////////////
 for(int i=0;i<=nbre_circuits;i++)
   {
   
    SoftPWM.set(i, ArduinoDmx0.RxBuffer[i]);  //buffers 0 indexed
   }


}  // end of ISR


